package org.bench4q.agent.scenario.node;

import java.util.ArrayList;
import java.util.Stack;

import org.bench4q.agent.datacollector.DataCollector;
import org.bench4q.agent.scenario.instruction.Instruction;
import org.bench4q.agent.scenario.instruction.TestInstruction;
import org.bench4q.share.exception.Bench4QRunTimeException;
import org.bench4q.share.models.agent.scriptrecord.BehaviorModel;
import org.bench4q.share.models.agent.statistics.BehaviorBriefModel;

public class ConditionBehavior extends PluginImplementBehavior {

	public ConditionBehavior(BehaviorModel condition) {
		if (!condition.getType().equalsIgnoreCase(TEST_BEHAVIOR)) {
			throw new Bench4QRunTimeException(
					"Expected type is TEST_BEHAVIOR, but is "
							+ condition.getType());
		}
		buildAndGenerateParameterPart(condition);
	}

	@Override
	public boolean shouldBeCount() {
		return false;
	}

	@Override
	public BehaviorBriefModel getBehaviorBriefResult(
			DataCollector dataStatistics) {
		return null;
	}

	@Override
	public void compile(ArrayList<Instruction> code,
			Stack<TestInstruction> conditions) {
	}

}
