package org.bench4q.agent.test.datastatistics;

import static org.junit.Assert.*;

import org.bench4q.agent.datacollector.impl.BehaviorsResultCollector;
import org.bench4q.agent.datacollector.impl.BehaviorsResultCollector.BehaviorResultCollector;
import org.bench4q.agent.scenario.engine.BehaviorResult;
import org.bench4q.share.models.agent.statistics.BehaviorBriefModel;
import org.bench4q.share.models.agent.statistics.BehaviorStatusCodeResultModel;
import org.junit.Test;

public class Test_BehaviorResultCollector {
	private BehaviorsResultCollector detailStatistics = new BehaviorsResultCollector();

	private BehaviorsResultCollector getDetailStatistics() {
		return detailStatistics;
	}

	//
	// private void setDetailStatistics(DataCollector detailStatistics) {
	// this.detailStatistics = detailStatistics;
	// }

	public Test_BehaviorResultCollector() {
		// init();
	}

	// private void init() {
	// @SuppressWarnings("resource")
	// ApplicationContext context = new ClassPathXmlApplicationContext(
	// "classpath*:/org/bench4q/agent/config/application-context.xml");
	// ScenarioResultCollector agentResultDataCollector = new
	// ScenarioResultCollector(
	// UUID.randomUUID());
	// agentResultDataCollector.setStorageHelper((StorageHelper) context
	// .getBean(StorageHelper.class));
	// this.setDetailStatistics(agentResultDataCollector);
	// }

	@Test
	public void addZeroTest() {
		for (BehaviorResult behaviorResult : Test_ScenarioBriefCollector
				.makeBehaviorList(0, 1)) {
			this.getDetailStatistics().add(behaviorResult);
		}

		Object object = this.detailStatistics.getStatistics(0);
		assertEquals(null, object);
	}

	@Test
	public void addOneDetailTest() {
		BehaviorResultCollector collector = new BehaviorResultCollector(1);
		for (BehaviorResult behaviorResult : Test_ScenarioBriefCollector
				.makeBehaviorList(1, 1)) {
			collector.add(behaviorResult);
		}
		BehaviorBriefModel briefModel = (BehaviorBriefModel) collector
				.getStatistics();
		assertEquals(briefModel.getSuccessfulCount(), 1);
		assertEquals(briefModel.getTotalCount(), 1);
		assertEquals(1, briefModel.getDetailStatusCodeResultModels().size());
		BehaviorStatusCodeResultModel resultModel = briefModel
				.getDetailStatusCodeResultModels().get(0);
		assertEquals(resultModel.getContentLength(), 20);
		assertEquals(resultModel.getCountThisTime(), 1);
		assertEquals(resultModel.getCount(), 1);
		assertEquals(resultModel.getMaxResponseTime(), 200);
		assertEquals(resultModel.getMinResponseTime(), 200);
		assertEquals(resultModel.getTotalResponseTimeThisTime(), 200);
	}

	@Test
	public void addTwoDetailTest() {
		int behaviorId = 1;
		BehaviorResultCollector collector = new BehaviorResultCollector(
				behaviorId);
		for (BehaviorResult behaviorResult : Test_ScenarioBriefCollector
				.makeBehaviorList(2, behaviorId)) {
			collector.add(behaviorResult);
		}
		BehaviorBriefModel briefModel = (BehaviorBriefModel) collector
				.getStatistics();
		assertEquals(1, briefModel.getSuccessfulCount());
		assertEquals(2, briefModel.getTotalCount());
		assertEquals(2, briefModel.getDetailStatusCodeResultModels().size());
		for (BehaviorStatusCodeResultModel statusCodeResultModel : briefModel
				.getDetailStatusCodeResultModels()) {
			if (statusCodeResultModel.getStatusCode() == 200) {
				assertEquals(statusCodeResultModel.getContentLength(), 20);
				assertEquals(statusCodeResultModel.getCount(), 1);
				assertEquals(statusCodeResultModel.getCountThisTime(), 1);
				assertEquals(statusCodeResultModel.getMaxResponseTime(), 200);
				assertEquals(statusCodeResultModel.getMinResponseTime(), 200);
				assertEquals(
						statusCodeResultModel.getTotalResponseTimeThisTime(),
						200);
			} else {
				assertEquals(statusCodeResultModel.getContentLength(), 0);
				assertEquals(statusCodeResultModel.getCount(), 1);
				assertEquals(statusCodeResultModel.getCountThisTime(), 1);
				assertEquals(statusCodeResultModel.getMaxResponseTime(),
						Long.MIN_VALUE);
				assertEquals(statusCodeResultModel.getMinResponseTime(),
						Long.MAX_VALUE);
				assertEquals(
						statusCodeResultModel.getTotalResponseTimeThisTime(), 0);
			}
		}
	}

	@Test
	public void test_addSomeSameUrlResult() {
	}
}
