package org.bench4q.agent.test.datastatistics;

import static org.junit.Assert.*;

import java.util.Arrays;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.UUID;

import org.bench4q.agent.datacollector.impl.DataCollectorImpl;
import org.bench4q.agent.scenario.engine.BehaviorResult;
import org.bench4q.agent.storage.StorageHelper;
import org.bench4q.share.models.agent.statistics.AgentBriefStatusModel;
import org.bench4q.share.models.agent.statistics.BehaviorBriefModel;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = { "classpath:application-context.xml" })
public class Test_DataCollectorImpl {
	private DataCollectorImpl dataCollectorImpl;

	public Test_DataCollectorImpl() {
		init();
	}

	private void init() {
		@SuppressWarnings("resource")
		ApplicationContext context = new ClassPathXmlApplicationContext(
				"classpath*:/org/bench4q/agent/config/application-context.xml");
		DataCollectorImpl agentResultDataCollector = new DataCollectorImpl(
				UUID.randomUUID(),
				(StorageHelper) context.getBean(StorageHelper.class));
		this.dataCollectorImpl = agentResultDataCollector;
	}

	@Test
	public void test() {
		BehaviorResult buildBehaviorResult = Test_ScenarioBriefCollector
				.buildBehaviorResult(200, true, 200, 1, new Date().getTime());
		this.dataCollectorImpl.add(buildBehaviorResult);
		BehaviorResult buildBehaviorResult2 = Test_ScenarioBriefCollector
				.buildBehaviorResult(400, false, 200, 1, new Date().getTime());
		this.dataCollectorImpl.add(buildBehaviorResult2);
		AgentBriefStatusModel model = (AgentBriefStatusModel) this.dataCollectorImpl
				.getScenarioBriefStatistics();
		judgeBehaviorTotalAndScenarioTotal(
				Arrays.asList(buildBehaviorResult, buildBehaviorResult2), model);
		this.dataCollectorImpl.add(Test_ScenarioBriefCollector
				.buildBehaviorResult(230, true, 200, 1, new Date().getTime()));
		model = (AgentBriefStatusModel) this.dataCollectorImpl
				.getScenarioBriefStatistics();
		judgeBehaviorTotalAndScenarioTotal(
				Arrays.asList(buildBehaviorResult, buildBehaviorResult2), model);
	}

	private void judgeBehaviorTotalAndScenarioTotal(
			List<BehaviorResult> generatedBehaviorResults,
			AgentBriefStatusModel model) {
		int successCount = 0, totalCount = 0;
		HashSet<Integer> set = new HashSet<Integer>();
		for (BehaviorResult unit : generatedBehaviorResults) {
			BehaviorBriefModel briefModel = (BehaviorBriefModel) this.dataCollectorImpl
					.getBehaviorBriefStatistics(unit.getBehaviorId());
			if (set.contains(unit.getBehaviorId()) || briefModel == null) {
				continue;
			}
			set.add(unit.getBehaviorId());
			successCount += briefModel.getSuccessfulCount();
			totalCount += briefModel.getTotalCount();
		}
		assertEquals((long) successCount, model.getSuccessCountFromBegin());
		assertEquals(
				totalCount,
				model.getSuccessCountFromBegin()
						+ model.getFailCountFromBegin());
	}
}
