package org.bench4q.master.domain.valueobject.datastatistics.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.bench4q.share.models.agent.statistics.BehaviorBriefModel;
import org.bench4q.share.models.agent.statistics.DataStatisticsModel;
import org.bench4q.share.models.agent.statistics.AgentBehaviorsBriefModel;
import org.bench4q.share.models.master.statistics.ScriptBehaviorBriefModel;
import org.bench4q.share.models.master.statistics.ScriptBehaviorsBriefModel;

public class BehaviorsBriefStatistics extends ScriptStatistics {
	private Map<Integer, String> idUrlMap;
	private Map<Integer, BehaviorBriefStatistics> behaviorStatisticsMap;

	private Map<Integer, String> getIdUrlMap() {
		return idUrlMap;
	}

	private void setIdUrlMap(Map<Integer, String> idUrlMap) {
		this.idUrlMap = idUrlMap;
	}

	private Map<Integer, BehaviorBriefStatistics> getBehaviorStatisticsMap() {
		return behaviorStatisticsMap;
	}

	private void setBehaviorStatisticsMap(
			Map<Integer, BehaviorBriefStatistics> behaviorStatisticsMap) {
		this.behaviorStatisticsMap = behaviorStatisticsMap;
	}

	public BehaviorsBriefStatistics() {
		this.setIdUrlMap(new ConcurrentHashMap<Integer, String>());
		this.setBehaviorStatisticsMap(new ConcurrentHashMap<Integer, BehaviorBriefStatistics>());
	}

	public ScriptBehaviorsBriefModel getStatistics() {
		ScriptBehaviorsBriefModel result = new ScriptBehaviorsBriefModel();
		List<ScriptBehaviorBriefModel> list = new ArrayList<ScriptBehaviorBriefModel>();
		for (int behaviorId : this.behaviorStatisticsMap.keySet()) {
			list.add((ScriptBehaviorBriefModel) this.behaviorStatisticsMap.get(
					behaviorId).getStatistics());
		}
		result.setBehaviorBriefModels(list);
		makeUpResultModelWithSamplingTime(result);
		return result;
	}

	public void add(DataStatisticsModel dataUnit) {
		if (!(dataUnit instanceof AgentBehaviorsBriefModel)) {
			return;
		}
		AgentBehaviorsBriefModel input = (AgentBehaviorsBriefModel) dataUnit;
		for (BehaviorBriefModel behaviorBriefModel : input
				.getBehaviorBriefModels()) {
			guardAllMapsKeyExists(behaviorBriefModel);
			this.getBehaviorStatisticsMap()
					.get(behaviorBriefModel.getBehaviorId())
					.add(behaviorBriefModel);

		}
	}

	private synchronized void guardAllMapsKeyExists(
			BehaviorBriefModel behaviorBriefModel) {
		int behaviorId = behaviorBriefModel.getBehaviorId();
		if (!this.getIdUrlMap().containsKey(behaviorId)) {
			this.getIdUrlMap().put(behaviorId,
					behaviorBriefModel.getBehaviorUrl());
		}
		if (!this.getBehaviorStatisticsMap().containsKey(behaviorId)) {
			this.getBehaviorStatisticsMap().put(
					behaviorId,
					new BehaviorBriefStatistics(behaviorId, behaviorBriefModel
							.getBehaviorUrl()));
		}
	}
}
