package org.bench4q.master.domain.valueobject.datastatistics.impl;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.bench4q.share.models.agent.statistics.AgentPageBriefModel;
import org.bench4q.share.models.agent.statistics.AgentPagesBriefModel;
import org.bench4q.share.models.agent.statistics.DataStatisticsModel;
import org.bench4q.share.models.master.statistics.ScriptPageBriefModel;
import org.bench4q.share.models.master.statistics.ScriptPagesBriefModel;

public class PagesBriefStatistics extends ScriptStatistics {
	private Map<Integer, PageBriefStatistics> map;

	private Map<Integer, PageBriefStatistics> getMap() {
		return map;
	}

	private void setMap(Map<Integer, PageBriefStatistics> map) {
		this.map = map;
	}

	public PagesBriefStatistics() {
		this.setMap(new ConcurrentHashMap<Integer, PageBriefStatistics>());
	}

	public void add(DataStatisticsModel dataUnit) {
		if (dataUnit instanceof AgentPagesBriefModel) {
			add((AgentPagesBriefModel) dataUnit);
		}
	}

	private void add(AgentPagesBriefModel agentPagesBriefModel) {
		for (AgentPageBriefModel unit : agentPagesBriefModel
				.getPageBriefModels()) {
			int key = unit.getPageId();
			if (!this.getMap().containsKey(key)) {
				guardMapKeyExists(key);
			}
			this.getMap().get(key).add(unit);
		}
	}

	private synchronized void guardMapKeyExists(int key) {
		if (!this.getMap().containsKey(key)) {
			this.getMap().put(key, new PageBriefStatistics());
		}
	}

	public Object getStatistics() {
		ScriptPagesBriefModel scriptPagesBriefModel = new ScriptPagesBriefModel();
		for (Integer key : this.getMap().keySet()) {
			scriptPagesBriefModel.getScriptPageBriefModels().add(
					(ScriptPageBriefModel) this.getMap().get(key)
							.getStatistics());
		}
		return scriptPagesBriefModel;
	}

}
