package org.bench4q.master.unitTest;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import org.apache.commons.io.FileUtils;
import org.bench4q.master.domain.RunningScriptInterface;
import org.bench4q.master.domain.entity.RunningAgentDB;
import org.bench4q.master.domain.entity.TestPlan;
import org.bench4q.master.domain.entity.TestPlanScript;
import org.bench4q.master.domain.entity.User;
import org.bench4q.master.domain.factory.TestPlanFactory;
import org.bench4q.master.domain.repository.AgentRepository;
import org.bench4q.master.domain.repository.TestPlanRepository;
import org.bench4q.master.domain.repository.UserRepository;
import org.bench4q.master.domain.service.AgentService;
import org.bench4q.master.domain.service.ScriptService;
import org.bench4q.master.domain.service.TestPlanEngine;
import org.bench4q.master.domain.service.TestPlanScriptResultService;
import org.bench4q.master.domain.service.TestPlanScriptService;
import org.bench4q.master.domain.service.TestPlanService;
import org.bench4q.master.domain.service.UserService;
import org.bench4q.master.exception.ExceptionUtils.IllegalParameterException;
import org.bench4q.master.helper.SessionHelper;
import org.bench4q.master.infrastructure.communication.AgentMessenger;
import org.bench4q.master.infrastructure.highavailable.HighAvailablePool;
import org.bench4q.master.unitTest.controller.TestBase;
import org.bench4q.share.enums.master.TestPlanStatus;
import org.bench4q.share.models.agent.ScriptFilterOptionsModel;
import org.bench4q.share.models.agent.scriptrecord.ScheduleModel;
import org.bench4q.share.models.agent.scriptrecord.ScheduleModel.PointModel;
import org.bench4q.share.models.master.MonitorModel;
import org.bench4q.share.models.master.RunningScriptModel;
import org.bench4q.share.models.master.TestPlanModel;
import org.bench4q.share.models.master.statistics.ScriptBriefResultModel;
import org.springframework.beans.factory.annotation.Autowired;

public class TestBase_MakeUpTestPlan extends TestBase {
	private SessionHelper sessionHelper;
	private TestPlanScriptResultService testPlanScriptResultService;
	private TestPlanScriptService testPlanScriptService;
	private TestPlanService testPlanService;
	private TestPlanRepository testPlanRepository;
	private UserService userService;
	private UserRepository userRepository;
	private ScriptService scriptService;
	private HighAvailablePool haPool;
	private AgentRepository agentRepository;
	private AgentMessenger agentMessenger;
	private TestPlanEngine testPlanEngine;
	private AgentService agentService;
	@Autowired
	protected TestPlanFactory testPlanFactory;
	private UUID testPlanRunIdUuid;
	private int scriptId;
	private int scriptIdForSecond;
	private User testUser;
	protected static int EACH_SCRIPT_LOAD_LargeSCALE = 1200;
	protected static int EACH_SCRIPT_LOAD_SMALLSCALE = 10;
	// private static int EACH_SCRIPT_LOAD_MIDDLESCALE = 800;
	public static String Monitor_Host_Name = "133.133.12.3";
	public static String monitor_port = "5556";
	public static final String Test_User_Name = "admin";
	public static final String Test_User_Password = "test1";
	public static final String Test_AGENT_HOSTNAME = "133.133.12.4";
	public static final int TEST_PORT = 6565;

	protected SessionHelper getSessionHelper() {
		return sessionHelper;
	}

	@Autowired
	protected void setSessionHelper(SessionHelper sessionHelper) {
		this.sessionHelper = sessionHelper;
	}

	public TestPlanScriptResultService getTestPlanScriptResultService() {
		return testPlanScriptResultService;
	}

	@Autowired
	public void setTestPlanScriptResultService(
			TestPlanScriptResultService testPlanScriptResultService) {
		this.testPlanScriptResultService = testPlanScriptResultService;
	}

	public TestPlanScriptService getTestPlanScriptService() {
		return testPlanScriptService;
	}

	@Autowired
	public void setTestPlanScriptService(
			TestPlanScriptService testPlanScriptService) {
		this.testPlanScriptService = testPlanScriptService;
	}

	public TestPlanService getTestPlanService() {
		return testPlanService;
	}

	@Autowired
	public void setTestPlanService(TestPlanService testPlanService) {
		this.testPlanService = testPlanService;
	}

	public UserService getUserService() {
		return userService;
	}

	@Autowired
	public void setUserService(UserService userService) {
		this.userService = userService;
	}

	protected UserRepository getUserRepository() {
		return userRepository;
	}

	@Autowired
	protected void setUserRepository(UserRepository userRepository) {
		this.userRepository = userRepository;
	}

	public ScriptService getScriptService() {
		return scriptService;
	}

	@Autowired
	public void setScriptService(ScriptService scriptService) {
		this.scriptService = scriptService;
	}

	protected TestPlanRepository getTestPlanRepository() {
		return testPlanRepository;
	}

	@Autowired
	private void setTestPlanRepository(TestPlanRepository testPlanRepository) {
		this.testPlanRepository = testPlanRepository;
	}

	protected HighAvailablePool getHaPool() {
		return haPool;
	}

	@Autowired
	protected void setHaPool(HighAvailablePool haPool) {
		this.haPool = haPool;
	}

	protected AgentRepository getAgentRepository() {
		return agentRepository;
	}

	@Autowired
	protected void setAgentRepository(AgentRepository agentRepository) {
		this.agentRepository = agentRepository;
	}

	protected AgentMessenger getAgentMessenger() {
		return agentMessenger;
	}

	@Autowired
	protected void setAgentMessenger(AgentMessenger agentMessenger) {
		this.agentMessenger = agentMessenger;
	}

	protected TestPlanEngine getTestPlanEngine() {
		return testPlanEngine;
	}

	@Autowired
	private void setTestPlanEngine(TestPlanEngine testPlanEngine) {
		this.testPlanEngine = testPlanEngine;
	}

	protected AgentService getAgentService() {
		return agentService;
	}

	@Autowired
	protected void setAgentService(AgentService agentService) {
		this.agentService = agentService;
	}

	public UUID getTestPlanRunIdUuid() {
		return testPlanRunIdUuid;
	}

	public void setTestPlanRunIdUuid(UUID testPlanRunIdUuid) {
		this.testPlanRunIdUuid = testPlanRunIdUuid;
	}

	public int getScriptId() {
		return scriptId;
	}

	public void setScriptId(int scriptId) {
		this.scriptId = scriptId;
	}

	protected int getScriptIdForSecond() {
		return scriptIdForSecond;
	}

	protected void setScriptIdForSecond(int scriptIdForSecond) {
		this.scriptIdForSecond = scriptIdForSecond;
	}

	protected User getTestUser() {
		if (this.userRepository.getUser(Test_User_Name) == null) {
			User user = new User();
			user.setUserName(Test_User_Name);
			user.setPassword(Test_User_Password);
			this.userRepository.attatch(user);
		}
		if (this.testUser == null) {
			this.testUser = this.userRepository.getUser(Test_User_Name);
		}
		return testUser;
	}

	protected void setTestUser(User testUser) {
		this.testUser = testUser;
	}

	/**
	 * 
	 */
	public TestBase_MakeUpTestPlan() {
	}

	protected void prepareForTestPlanRunning() {
		this.getHaPool().checkAllHeartBeat();
	}

	protected void cleanUpForTestPlanRunning() {
		TestPlan testPlan = this.getTestPlanRepository().getTestPlanInDomainBy(
				getTestPlanRunIdUuid());
		if (testPlan == null) {
			return;
		}
		testPlan.setCurrentStatus(TestPlanStatus.Complete.name());
		RunningAgentDB runningAgent = extractTheFirstRunningAgent(testPlan
				.extracSpecifiedScript(getScriptId()));
		RunningScriptInterface runningScript = testPlan
				.extracSpecifiedScript(getScriptId());
		runningScript.stop();
		if (runningAgent == null)
			return;
		this.getAgentMessenger().stop(runningAgent.getAgent(),
				runningAgent.getAgentRunId());
		runningAgent.getAgent().setRemainLoad(
				runningAgent.getAgent().getMaxLoad());
		this.getAgentRepository().update(runningAgent.getAgent());
		this.getTestPlanRepository().detach(testPlan.getId());
	}

	protected RunningAgentDB extractTheFirstRunningAgent(
			TestPlanScript testPlanScript) {
		for (RunningAgentDB runningAgentDB : testPlanScript
				.getRunningAgentsDB()) {
			return runningAgentDB;
		}
		return null;
	}

	protected UUID submitATestPlanWithOneScript(int load) {
		return submitATestPlan(1, load);
	}

	protected UUID submitATestPlanWithTwoScript(int load) {
		return submitATestPlan(2, load);
	}

	private UUID submitATestPlan(int i, int load) {
		UUID testPlanRunId = UUID.randomUUID();
		User user = this.getUserRepository().getUser(Test_User_Name);
		int scriptOne = getUserFirstScript(user);
		this.setScriptId(scriptOne);
		int scriptTwo = -1;
		TestPlanModel model = null;
		if (i == 2) {
			scriptTwo = getUserSecondScript(user);
			this.setScriptIdForSecond(scriptTwo);
			model = createATestPlanWithTwoScript(scriptOne, scriptTwo, load);
		} else {
			model = createATestPlanWithOneScript(scriptOne, load);
		}
		try {
			this.getTestPlanEngine().submitTestPlan(model, user, testPlanRunId);
		} catch (Exception e) {
			e.printStackTrace();
		}

		this.setTestPlanRunIdUuid(testPlanRunId);
		return testPlanRunId;
	}

	public TestPlanModel createATestPlanWithOneScript(int scriptId, int load) {
		TestPlanModel testPlanBusinessModel = new TestPlanModel();
		testPlanBusinessModel.setMonitorModels(createOneMonitorList());
		testPlanBusinessModel.setRunningScriptModels(createOneScriptList(
				scriptId, load));
		this.setScriptId(scriptId);
		return testPlanBusinessModel;
	}

	public UUID submitATestPlanWithScriptName(int load) {
		UUID testPlanRunId = UUID.randomUUID();
		User user = this.getUserRepository().getUser("admin");
		int scriptOne = getUserFirstScript(user);
		this.setScriptId(scriptOne);
		TestPlanModel model = null;

		model = createAtestPlanWithOneScriptAndName(load);
		try {
			this.getTestPlanEngine().submitTestPlan(model, user, testPlanRunId);
		} catch (IllegalParameterException e) {
			e.printStackTrace();
		}
		this.setTestPlanRunIdUuid(testPlanRunId);
		return testPlanRunId;
	}

	public TestPlanModel createAtestPlanWithOneScriptAndName(int load) {
		TestPlanModel testPlanBusinessModel = new TestPlanModel();
		testPlanBusinessModel.setName("testName");
		testPlanBusinessModel.setMonitorModels(createOneMonitorList());
		testPlanBusinessModel.setRunningScriptModels(createOneScriptList(
				scriptId, load));
		this.setScriptId(scriptId);
		return testPlanBusinessModel;
	}

	protected TestPlanModel createATestPlanWithTwoScript(int scriptIdForOne,
			int scriptIdForTwo, int load) {
		TestPlanModel testPlanBusinessModel = new TestPlanModel();
		testPlanBusinessModel.setMonitorModels(createOneMonitorList());
		testPlanBusinessModel.setRunningScriptModels(createTwoScriptList(
				scriptIdForOne, scriptIdForTwo, load));
		return testPlanBusinessModel;
	}

	private List<RunningScriptModel> createTwoScriptList(int scriptIdForOne,
			int scriptIdForTwo, int load) {
		List<RunningScriptModel> runningScriptModels = createOneScriptList(
				scriptIdForOne, load);
		runningScriptModels.add(buildScriptModel(scriptIdForTwo, load));
		return runningScriptModels;
	}

	protected int getUserFirstScript(User user) {
		if (this.getScriptService().loadScripts(getTestUser()).size() == 0) {
			try {
				this.scriptService.saveScript("test1", getTestUser().getId(),
						FileUtils.readFileToString(new File(
								"Scripts/homepage.xml")), null);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return this.getScriptService().loadScripts(user).get(0).getId();
	}

	protected int getUserSecondScript(User user) {
		return this.getScriptService().loadScripts(user).get(1).getId();
	}

	protected void deleteTestPlan() {
		this.getTestPlanRepository().detach(
				this.getTestPlanRepository()
						.getTestPlanInDomainBy(this.getTestPlanRunIdUuid())
						.getId());
	}

	protected ScriptBriefResultModel buildScriptBriefResultModel(int i) {
		ScriptBriefResultModel resultModel = new ScriptBriefResultModel();
		resultModel.setAverageElapsedTime(100 * i);
		resultModel.setAverageResponseTime(100 * i);
		resultModel.setFailRateThisTime(10 * i);
		return resultModel;
	}

	public static List<MonitorModel> createOneMonitorList() {
		List<MonitorModel> monitors = new ArrayList<MonitorModel>();
		monitors.add(buildMonitorModel());
		return monitors;
	}

	public static List<RunningScriptModel> createOneScriptList(int scriptId,
			int load) {
		List<RunningScriptModel> list = new ArrayList<RunningScriptModel>();
		list.add(buildScriptModel(scriptId, load));
		return list;
	}

	public static RunningScriptModel buildScriptModel(int scriptID, int load) {
		RunningScriptModel model = new RunningScriptModel();
		model.setScriptId(scriptID);
		model.setScriptFilterOptionsModel(new ScriptFilterOptionsModel());
		model.setRequireLoad(load);
		ScheduleModel schedule = new ScheduleModel();
		schedule.getPoints().add(new PointModel(0, 0));
		schedule.getPoints().add(new PointModel(20, load));
		schedule.getPoints().add(new PointModel(60, load));
		schedule.getPoints().add(new PointModel(80, 0));
		model.setScheduleModel(schedule);
		return model;
	}

	private static MonitorModel buildMonitorModel() {
		MonitorModel monitorModel = new MonitorModel();
		monitorModel.setHostName(Monitor_Host_Name);
		monitorModel.setPort(Integer.parseInt(monitor_port));
		return monitorModel;
	}

	public TestPlan fetchTestPlan() {
		return this.getTestPlanRepository().getTestPlanInDomainBy(
				getTestPlanRunIdUuid());
	}
}
