package org.bench4q.monitor.model;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

import org.hyperic.sigar.SigarException;


@XmlRootElement(name = "limitableFields")
public class LimitableFieldsModel {
	private List<String> fieldsParent;
	private List<String> fields;
	@XmlElementWrapper(name = "fieldList")
	@XmlElement(name = "field")
	public List<String> getFields() {
		return fields;
	}

	public void setFields(List<String> fields) {
		this.fields = fields;
	}

	public LimitableFieldsModel() throws SigarException {
		this.fields = new ArrayList<String>();
		this.fieldsParent = new ArrayList<String>();
		String stringMemoryModel = new MemoryModel().getClass().getName();
		String stringProcessorModel = new ProcessorModel().getClass().getName();
		this.fields.add("MemoryUsedPercent");
		this.fieldsParent.add(stringMemoryModel);
		this.fields.add("ProcessorTimePercent");
		this.fieldsParent.add(stringProcessorModel);
		this.fields.add("UserTimePercent");
		this.fieldsParent.add(stringProcessorModel);
		this.fields.add("PrivilegedTimePercent");
		this.fieldsParent.add(stringProcessorModel);
	}
	
	public String validname(String name){
		for (int i = 0; i < this.fields.size(); i++){
			if (name.toUpperCase().equals(fields.get(i).toUpperCase()))
				return fieldsParent.get(i);
			}
			return "";
	}
	
	public List<String> getFieldsParent() {
		return fieldsParent;
	}

	public void setFieldsParent(List<String> fieldsParent) {
		this.fieldsParent = fieldsParent;
	}

	public static void main(String args[]) throws SigarException{
		LimitableFieldsModel limitableFieldsModel = new LimitableFieldsModel();
		System.out.println(limitableFieldsModel.getFields());
	}
}
