package org.bench4q.share.models.agent.scriptrecord;

import java.util.List;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

import org.bench4q.share.models.agent.ParameterModel;

@XmlRootElement
public class PluginedBehaviorModel extends BehaviorModel {
	private String use;
	private String name;
	private String type;
	private List<ParameterModel> parameters;

	@XmlElement
	public String getUse() {
		return use;
	}

	public void setUse(String use) {
		this.use = use;
	}

	@XmlElement
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@XmlElement
	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	@XmlElementWrapper(name = "parameters")
	@XmlElement(name = "parameter")
	public List<ParameterModel> getParameters() {
		return parameters;
	}

	public void setParameters(List<ParameterModel> parameters) {
		this.parameters = parameters;
	}

	@XmlRootElement
	public static class UserBehaviorModel extends PluginedBehaviorModel {
	}

	@XmlRootElement
	public static class TimerBehaviorModel extends PluginedBehaviorModel {
	}

	@XmlRootElement
	public static class ControlBehaviorModel extends PluginedBehaviorModel {
	}

	@XmlRootElement
	public static class ConditionBehaviorModel extends PluginedBehaviorModel {
	}
}
